UNIT FEXLIB;

INTERFACE

type
  list = array[1..10] of STRING[5];

 TYPE
{SECTOR=ARRAY[0..10751] OF BYTE;}
SECTOR=ARRAY[0..10] OF BYTE;


TYPEBOOT = RECORD
         reservado   : ARRAY[0..2] OF BYTE;
         OEMID       : ARRAY[0..7] OF CHAR;
         BYTPERSEC   : WORD;
         SECPERCLUS  : BYTE;
         RESECATBEG  : WORD;
         FATcopies   : BYTE;
         ROOTDIRENT  : WORD;
         TOTSECONDISK: WORD;
         MEDIADESC   : BYTE;
         SECPERFAT   : WORD;
         SECPERTRAC  : WORD;
         SIDES       : WORD;
         SPEHIDSEC   : LONGINT;
         BIGTOTNUMSEC: LONGINT;
         DRIVENUM    : WORD;
         EXTBOOTRSIG : BYTE;
         VOLSERIALNUM: LONGINT;
         LABELVOL    : ARRAY [0..10] OF CHAR;
         FILESYSID   : ARRAY [0..4] OF CHAR;
         BOOTPROGRAM : ARRAY[0..452] OF BYTE;

END;

CONST MAXFIELDS=32;

VAR
_DK:BYTE;
_DATAPTR: ARRAY[1..MAXFIELDS] OF POINTER;
_DATAPROMPT:ARRAY[1..MAXFIELDS] OF STRING;
_DATATIPO:ARRAY[1..MAXFIELDS] OF CHAR;
_DATAEXIT:BYTE;
_DATAF:ARRAY[1..MAXFIELDS] OF BYTE;
_DATAC:ARRAY[1..MAXFIELDS] OF BYTE;
_DATASIZE:ARRAY[1..MAXFIELDS] OF BYTE;
_DATADEC:ARRAY[1..MAXFIELDS] OF BYTE;
_DATACOL1,_DATACOL2:BYTE;


{******** Lista de Procedimientos y Funciones en la Libreria******}

procedure ssort(var a: list; Lo,Hi: integer);
FUNCTION LEFT(CAD1:STRING;CPOS:INTEGER): STRING;
FUNCTION RIGHT(CAD1:STRING;CPOS:INTEGER): STRING;
FUNCTION LEN(CAD1:STRING): INTEGER;
FUNCTION AT(CAD1,CAD2:STRING): INTEGER;
FUNCTION SUBSTR(CAD1:STRING;CPOS1,CPOS2:INTEGER): STRING;
FUNCTION EMPTY(CAD1:STRING): BOOLEAN;
FUNCTION RAT(CAD1,CAD2:STRING): INTEGER;
FUNCTION IIFS(CONDICION:BOOLEAN;VERDAD,FALSO:STRING):STRING;
FUNCTION IIFN(CONDICION:BOOLEAN;VERDAD,FALSO:INTEGER):INTEGER;
FUNCTION IIFL(CONDICION:BOOLEAN;VERDAD,FALSO:BOOLEAN):BOOLEAN;
FUNCTION EQUAL(CAD1,CAD2:STRING): INTEGER;
FUNCTION LIKE(CAD1,CAD2:STRING):BOOLEAN;
PROCEDURE PSET(X,Y:WORD;COLOR:BYTE);
PROCEDURE LINEA(XI,YI,XF,YF:REAL;COLOR:byte);
PROCEDURE PAUSA;
PROCEDURE SCREEN256;
PROCEDURE SCREEN0;
PROCEDURE LINEABOX(X1,Y1,X2,Y2:REAL;COLOR:BYTE;FILL:BOOLEAN);
PROCEDURE SAVESCR;
PROCEDURE RESTORESCR;
FUNCTION BIT(valor:BYTE;numbit:integer):BOOLEAN;
FUNCTION ISCOLOR:BOOLEAN;
PROCEDURE CLS;
FUNCTION CURDRIVE:STRING;
FUNCTION DRIVEVAL(unidad:STRING):byte;
PROCEDURE RESETDISK(unidad:STRING);
FUNCTION READSECTOR(unidad:STRING;numsec,cilindro,sector,lado:BYTE;VAR buffer:SECTOR):BYTE;
FUNCTION READBOOT(unidad:STRING;VAR buffer:TYPEBOOT):BYTE;
FUNCTION DISKERROR(ERROR:BYTE):STRING;
function HEX(w: Word):STRING;
FUNCTION TRIM(cadena:string):STRING;
FUNCTION LTRIM(cadena:string):STRING;
FUNCTION GETKEYCODE:byte;
FUNCTION INKEY(VAR CAR:CHAR):byte;

PROCEDURE GOTOFC(var fila,columna:integer);
FUNCTION GETCHAR(FILA,COLUMNA:INTEGER):CHAR;
FUNCTION GETLINCHAR(FILA,COL1,COL2:INTEGER):STRING;
{procedure GETLINCHAR(FILA,COL1,COL2:INTEGER);}

FUNCTION REPLICATE(CADENA:STRING;CUENTA:INTEGER):STRING;
PROCEDURE LOCATE(F,C:INTEGER);
PROCEDURE SAY(F,C:INTEGER;ROTULO:STRING);
PROCEDURE SINGLEBOX(F1,C1,F2,C2:INTEGER);
PROCEDURE DOUBLEBOX(F1,C1,F2,C2:INTEGER);
PROCEDURE SAVECURSOR(VAR F,C:INTEGER);
PROCEDURE CLEARWINDOW;
PROCEDURE REMOVE(CADENA1:STRING;VAR CADENA2:STRING);
FUNCTION VALSTR(CADENA:STRING):REAL;
FUNCTION ENCRIPT(cadena:string):string;
FUNCTION DESENCRIPT(cadena:string):string;
procedure setrgb(registro:word;r,g,b:byte);
procedure getbufer(var tecla,codigo:char);
procedure putcharbuf(caracter,codigo:byte);
FUNCTION WRITESECTOR(unidad:STRING;numsec,cilindro,sector,lado:BYTE;VAR buffer:SECTOR):BYTE;
function exist(filename:string):boolean;
procedure kbdtasa(retardo,velocidad:byte);
PROCEDURE HIDECURSOR;
PROCEDURE SHOWCURSOR;
function transform(valor:real;ancho,decimals:byte):string;
FUNCTION STRLIKE(CADENA1,CADENA2:STRING):BOOLEAN;
PROCEDURE SET_COLOR(F,B:BYTE);
FUNCTION INSERTSTR(ORIGEN,DESTINO:STRING;INDEX:INTEGER):STRING;
FUNCTION DELSTR(DESTINO:STRING;INDEX,COUNT:INTEGER):STRING;
PROCEDURE GETDATA(F,C:BYTE; PROMPT:STRING;VAR DATA:STRING; TIPO:CHAR);
function READDATA:byte;
PROCEDURE DATACOLOR(COL1,COL2:BYTE);
FUNCTION SPACE(K:BYTE):STRING;
procedure shell;



{******** fin de la LIsta ****************}




implementation
uses crt,dos,PRINTER;

{**** SSORT RUTINA PARA ORDENAR UN ARRAY STRING ****}

procedure ssort(var a: list; Lo,Hi: integer);

procedure sort(l,r: integer);
var
  i,j: integer;
  X,Y:     STRING[30];
begin
  i:=l; j:=r; x:=a[(l+r) DIV 2];
  repeat
    while a[i]<x do i:=i+1;
    while x<a[j] do j:=j-1;
    if i<=j then
    begin
      y:=a[i]; a[i]:=a[j]; a[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

begin {quicksort};
  sort(Lo,Hi);
end;
{****** FIN DEL PROCEDIMIENTO DE SSORT ********}

FUNCTION LEFT(CAD1:STRING;CPOS:INTEGER): STRING;
BEGIN
LEFT:=(COPY(CAD1,1,CPOS));
END;

FUNCTION RIGHT(CAD1:STRING;CPOS:INTEGER): STRING;
BEGIN
RIGHT:=(COPY(CAD1, LENGTH(CAD1)-CPOS+1,CPOS ));
END;


FUNCTION LEN(CAD1:STRING): INTEGER;
BEGIN
LEN:=LENGTH(CAD1);
END;

FUNCTION AT(CAD1,CAD2:STRING): INTEGER;
BEGIN
AT:=POS(CAD1,CAD2);
END;

FUNCTION SUBSTR(CAD1:STRING;CPOS1,CPOS2:INTEGER): STRING;
BEGIN
IF CPOS2<>0 THEN
   SUBSTR:=COPY(CAD1,CPOS1,CPOS2)
ELSE
   SUBSTR:=COPY(CAD1,CPOS1,LENGTH(CAD1)-CPOS1+1);
END;

FUNCTION EMPTY(CAD1:STRING): BOOLEAN;
BEGIN
EMPTY:=LENGTH(CAD1)=0;
END;


FUNCTION RAT(CAD1,CAD2:STRING): INTEGER;

VAR
CADT:STRING;
POSS,LONG1,X:INTEGER;

BEGIN
LONG1:=LEN(CAD2);
CADT:='';
FOR X:=LONG1 DOWNTO 1 DO
CADT:=CADT+COPY(CAD2,X,1);
POSS:=POS(CAD1,CADT);

IF POSS<>0 THEN
RAT:=(LONG1-POSS)+1
ELSE
RAT:=0;
END;

FUNCTION IIFS(CONDICION:BOOLEAN;VERDAD,FALSO:STRING):STRING;

BEGIN
IF CONDICION THEN
IIFS:=VERDAD
ELSE
IIFS:=FALSO;
END;


FUNCTION IIFN(CONDICION:BOOLEAN;VERDAD,FALSO:INTEGER):INTEGER;

BEGIN
IF CONDICION THEN
IIFN:=VERDAD
ELSE
IIFN:=FALSO;
END;

FUNCTION IIFL(CONDICION:BOOLEAN;VERDAD,FALSO:BOOLEAN):BOOLEAN;

BEGIN
IF CONDICION THEN
IIFL:=VERDAD
ELSE
IIFL:=FALSO;
END;




FUNCTION EQUAL(CAD1,CAD2:STRING): INTEGER;
VAR
POS1,POS2:INTEGER;
CARACTER:STRING;
FLAGG,SWITCH:BOOLEAN;

BEGIN
    FLAGG:=TRUE;

    IF AT('?',CAD1)=0 THEN
       BEGIN
           FLAGG:=FALSE;
           POS2:=IIFN( (EMPTY(CAD1)) AND (EMPTY(CAD2)),1,AT(CAD1,CAD2));
       END;

    IF (FLAGG) AND (LEN(CAD1)>LEN(CAD2)) THEN
       BEGIN
           FLAGG:=FALSE;
           POS2:=0;
       END;


    IF FLAGG THEN
       BEGIN
           SWITCH:=TRUE;
           FOR POS2:=1 TO LEN(CAD2)-LEN(CAD1)+1 DO

           BEGIN
               SWITCH:=TRUE;
               FOR POS1:=1 TO LEN(CAD1) DO

               BEGIN
                   CARACTER:=SUBSTR(CAD1,POS1,1);
                   IF (CARACTER<>SUBSTR(CAD2,POS1+POS2-1,1)) AND (CARACTER<>'?') THEN SWITCH:=FALSE;
               END;
               IF SWITCH THEN EXIT;
            END;
            POS2:=IIFN(SWITCH,POS2,0)
         END;
EQUAL:=POS2
END;


FUNCTION LIKE(CAD1,CAD2:STRING):BOOLEAN;
VAR
SALIDA:BOOLEAN;
POS1,POS2,POSAST,POSFOUND:INTEGER;
SUBCAD1R,SUBCAD1L,SUBCAD2R,SUBCAD2L:STRING;

BEGIN
    POS1:=AT('**',CAD1);
    WHILE (POS1<LEN(CAD1)) AND (AT('**',CAD1)<>0) DO
    BEGIN
        IF (SUBSTR(CAD1,POS1,1)='*') AND (SUBSTR(CAD1,POS1+1,1)='*') THEN
           CAD1:=SUBSTR(CAD1,1,POS1)+SUBSTR(CAD1,POS1+2,0)
        ELSE
           POS1:=POS1+1;
     END;

     POS1:= AT('*',CAD1);
     POS2:=RAT('*',CAD1);
     SUBCAD1L:=IIFS(POS1=1,'',LEFT(CAD1,POS1-1));
     SUBCAD2L:=IIFS(POS1=1,'',LEFT(CAD2,POS1-1));
     SUBCAD1R:=IIFS(POS2=LEN(CAD1),'',SUBSTR(CAD1,POS1-1,0));
     SUBCAD2R:=SUBSTR(CAD2,POS1,0);
     SUBCAD2R:=IIFS( POS2=LEN(CAD1),'',RIGHT(SUBCAD2R,LEN(SUBCAD1R)));
     SUBCAD2R:=IIFS(POS2=0,CAD2,SUBCAD2R);

     SALIDA:=IIFL(  (EQUAL(SUBCAD1L,SUBCAD2L)>0)  AND
                    (LEN(SUBCAD1L)=LEN(SUBCAD2L)) AND
                    (EQUAL(SUBCAD1R,SUBCAD2R)>0)  AND
                    (LEN(SUBCAD1R)=LEN(SUBCAD2R)),TRUE,FALSE);

     IF SALIDA THEN
        BEGIN
            CAD2:=SUBSTR(CAD2,POS1,LEN(CAD2)-LEN(CAD1)-POS1+POS2+1);
            CAD1:=SUBSTR(CAD1,POS1+1,POS2-POS1-1)+'*';
            WHILE NOT ( (EMPTY(CAD1)) AND (LEFT(CAD1,1)<>'*')) DO
                  BEGIN
                       POSAST:=AT('*',CAD1);
                       SUBCAD1L:=LEFT(CAD1,POSAST-1);
                       POSFOUND:=EQUAL(SUBCAD1L,CAD2);

                       IF POSFOUND<>0 THEN
                           BEGIN
                               CAD1:=SUBSTR(CAD1,POSAST+1,0);
                               CAD2:=SUBSTR(CAD2,POSFOUND+LEN(SUBCAD1L),0);
                            END
                       ELSE
                            BEGIN
                                 SALIDA:=FALSE;
                                 EXIT;
                             END;
                  END;
        END;

     LIKE:=SALIDA;
END;





PROCEDURE PSET(X,Y:WORD;COLOR:BYTE);

BEGIN

ASM
MOV AH,0CH
MOV AL,&COLOR
MOV BH,0
MOV CX,&X
MOV DX,&Y
INT 10H
END;

END;

PROCEDURE LINEA(XI,YI,XF,YF:REAL;COLOR:byte);

VAR
DX,DY,K,MX,MY,INCX,INCY,XX,YY:REAL;
X,Y:WORD;
T:LONGINT;

BEGIN
  DX:=ABS(XF-XI);
  DY:=ABS(YF-YI);
  INCX:=0;
  INCY:=0;
  K:=0;
  MX:=0;
  MY:=0;
  T:=0;


  IF (DX<>0) OR (DY<>0) THEN
  BEGIN
    IF DX>=DY THEN K:=DX ELSE K:=DY;
    IF XF>XI THEN MX:=1;
    IF XF=XI THEN MX:=0;
    IF XF<XI THEN MX:=-1;

    IF YF>YI THEN MY:=1;
    IF YF=YI THEN MY:=0;
    IF YF<YI THEN MY:=-1;

    IF DX>=DY THEN
       BEGIN
          INCX:=MX;
          INCY:=(DY/DX)*MY;
       END
    ELSE
       BEGIN
          INCY:=MY;
          INCX:=(DX/DY)*MX;
    END;
    XX:=XI;
    YY:=YI;
    X:=ROUND(XI);
    Y:=ROUND(YI);

    FOR T:=1 TO ROUND(K)+1 DO
      BEGIN
        PSET(X,Y,color);
        XX:=XX+INCX;
        YY:=YY+INCY;
        X:=ROUND(XX);
        Y:=ROUND(YY);
      END;
  END;
END;

PROCEDURE PAUSA;

VAR CAR:CHAR;
BEGIN
CAR:=READKEY;











 END;

PROCEDURE SCREEN256;
BEGIN
ASM
MOV AH,0
MOV AL,13H
INT 10H
END;
END;

PROCEDURE SCREEN0;
BEGIN
ASM
MOV AH,0
MOV AL,3H
INT 10H
END;
END;


PROCEDURE LINEABOX(X1,Y1,X2,Y2:REAL;COLOR:BYTE;FILL:BOOLEAN);
VAR
R:INTEGER;
INCY:REAL;

BEGIN
LINEA(X1,Y1,X2,Y1,COLOR);
LINEA(X1,Y2,X2,Y2,COLOR);
LINEA(X1,Y1,X1,Y2,COLOR);
LINEA(X2,Y1,X2,Y2,COLOR);

IF FILL THEN
   BEGIN
      IF Y1<Y2 THEN INCY:=1 ELSE INCY:=-1;
      FOR R:=1 TO ROUND(ABS(Y1-Y2)) DO
          BEGIN
             LINEA(X1,Y1,X2,Y1,COLOR);
             Y1:=Y1+INCY;
          END;
END;


END;

procedure savescr;
var
origenc: byte absolute $b800:0000;
destinoc:byte absolute $b800:4000;

origenm: byte absolute $b000:0000;
destinom:byte absolute $b000:4000;


begin
  if iscolor then move(origenc,destinoc,4000) else move(origenm,destinom,4000);
end;


procedure restorescr;
var
origenc: byte absolute $b800:0000;
destinoc:byte absolute $b800:4000;

origenm: byte absolute $b000:0000;
destinom:byte absolute $b000:4000;


begin
  if iscolor then move(destinoc,origenc,4000) else move(destinom,origenm,4000);
end;






FUNCTION BIT(valor:BYTE;numbit:integer):BOOLEAN;

BEGIN
  VALOR:=VALOR SHL (7-NUMBIT);
  VALOR:=VALOR SHR 7;
  IF VALOR=1 THEN BIT:=TRUE ELSE BIT:=FALSE;
END;

FUNCTION ISCOLOR:BOOLEAN;
VAR
COL:BYTE;

BEGIN
  ASM
    MOV AH,12H
    MOV BL,10H
    INT 10H
    MOV &COL,BH
  END;
  IF COL=1 THEN ISCOLOR:=FALSE ELSE ISCOLOR:=TRUE;
END;

PROCEDURE CLS;
BEGIN
CLRSCR;
END;

FUNCTION CURDRIVE:STRING;
VAR
S:STRING;
BEGIN
   GETDIR(0,S);
   CURDRIVE:=LEFT(S,2);
END;


FUNCTION DRIVEVAL(unidad:STRING):byte;
VAR
unid:BYTE;

BEGIN
unid:=255;

  IF (unidad='') then unidad:=curdrive;
  IF (unidad='A:') OR (unidad='a:') then unid:=0;
  IF (unidad='B:') OR (unidad='b:') then unid:=1;
  IF (unidad='C:') OR (unidad='c:') then unid:=$80;
  IF (unidad='D:') OR (unidad='d:') then unid:=$81;
  IF (unidad='E:') OR (unidad='e:') then unid:=$82;


  DRIVEVAL:=unid;
END;


PROCEDURE RESETDISK(unidad:STRING);
VAR
unid:BYTE;

BEGIN
unid:=DRIVEVAL(unidad);

ASM
  MOV AH,0
  MOV DL,&UNID
  INT 13H
END;

END;

FUNCTION READSECTOR(unidad:STRING;numsec,cilindro,sector,lado:BYTE;VAR buffer:SECTOR):BYTE;
var
unid:byte;
estado:byte;
retrys:byte;
XOFFSET:WORD;


begin

unid:=DRIVEVAL(unidad);
retrys:=0;
estado:=0;
XOFFSET:=OFS(BUFFER);

REPEAT


ASM
  PUSH ES
  MOV AX,DS
  MOV ES,AX

  MOV AH,02H
  MOV AL,&numsec
  MOV CH,&cilindro
  MOV CL,&sector
  MOV DH,&lado
  MOV DL,&unid
  MOV BX,&XOFFSET
  INT 13H
  MOV &estado,AH
  POP ES
END;
INC(RETRYS);

UNTIL (estado=0) OR (RETRYS=3);
READSECTOR:=ESTADO;
END;

FUNCTION READBOOT(unidad:STRING;VAR buffer:TYPEBOOT):BYTE;
var
unid:byte;
estado:byte;
retrys:byte;
side:byte;
XOFFSET:WORD;

begin

unid:=DRIVEVAL(unidad);
retrys:=0;
estado:=0;

XOFFSET:=OFS(BUFFER);

IF unid>=$80 THEN side:=1 else side:=0;


REPEAT

ASM
  PUSH ES
  MOV AX,DS
  MOV ES,AX

  MOV AH,02H
  MOV AL,1
  MOV CH,0
  MOV CL,1
  MOV DH,&side
  MOV DL,&unid
  MOV BX,&XOFFSET
  INT 13H
  MOV &estado,AH
  POP ES
END;
INC(RETRYS);

UNTIL (estado=0) OR (RETRYS=3);

READBOOT:=ESTADO;
END;


FUNCTION DISKERROR(ERROR:BYTE):STRING;
VAR

ERR:STRING;

begin

err:='OK.';

IF ERROR=$01 THEN ERR:='Orden no valida.';
IF ERROR=$02 THEN ERR:='Marca de direccin no hallada';
IF ERROR=$03 THEN ERR:='Disco protegido contra escritura';
IF ERROR=$04 THEN ERR:='Sector no hallado';
IF ERROR=$05 THEN ERR:='Reinicializacin fallida';
IF ERROR=$06 THEN ERR:='Disco Retirado';
IF ERROR=$07 THEN ERR:='Tabla de parametros errnea';
IF ERROR=$08 THEN ERR:='DMA superado';
IF ERROR=$09 THEN ERR:='DMA ha superado el lmite de 64K';
IF ERROR=$0A THEN ERR:='Sector defectuoso';
IF ERROR=$0B THEN ERR:='Pista defectuosa';
IF ERROR=$0C THEN ERR:='Tipo de entorno no hallado';
IF ERROR=$0D THEN ERR:='Numero de sector no valido en el formato';
IF ERROR=$0E THEN ERR:='Hallada marca de la direccin de control de datos';
IF ERROR=$0F THEN ERR:='Nivel de arbitracin del DMA fuera de rango';
IF ERROR=$10 THEN ERR:='Error irrecuperable de CRC o de ECC';
IF ERROR=$11 THEN ERR:='Error ECC de datos corregido';
IF ERROR=$20 THEN ERR:='Fallo del controlador';
IF ERROR=$40 THEN ERR:='Fallo en bqueda';
IF ERROR=$80 THEN ERR:='Disco no respondi';
IF ERROR=$AA THEN ERR:='Unidad no preparada';
IF ERROR=$BB THEN ERR:='Error indefinido';
IF ERROR=$CC THEN ERR:='Fallo de escritura';
IF ERROR=$E0 THEN ERR:='Error de registro de estado';
IF ERROR=$FF THEN ERR:='Fallo de la operacin de deteccin';
DISKERROR:=ERR;
END;

function HEX(w: Word):STRING;
const
  hexChars: array [0..$F] of Char =
    '0123456789ABCDEF';
begin
HEX:=hexChars[Hi(w) shr 4]+hexChars[Hi(w) and $F]+hexChars[Lo(w) shr 4]+hexChars[Lo(w) and $F];
end;


FUNCTION TRIM(cadena:string):STRING;
var
l:integer;
begin
  l:=len(cadena);
  while cadena[l]=' ' do l:=l-1;
  TRIM:=left(cadena,l);
end;


FUNCTION LTRIM(cadena:string):STRING;
var
l:integer;
begin
  l:=1;
  while (cadena[l]=' ') and (l<=len(cadena)) do l:=l+1;
  LTRIM:=right(cadena,len(cadena)-l+1);
end;

FUNCTION GETKEYCODE:byte;
begin
asm
  MOV AH,10H
  INT 16H
  MOV @RESULT,AH
END;
END;

FUNCTION INKEY(VAR CAR:CHAR):byte;
VAR
CARACTER:CHAR;

begin
CARACTER:=CHR(0);
  IF memw[0:$41A]<>memw[0:$41C] THEN
 BEGIN
asm
  MOV AH,11H
  INT 16H
  MOV @RESULT,AH
  MOV CARACTER,AL
END;
  memw[0:$41c]:=memw[0:$41a];
END
 ELSE
 BEGIN
      INKEY:=0;
   END;
   CAR:=CARACTER;
END;




PROCEDURE GOTOFC(var fila,columna:integer);
var
pant:pointer;
key:BYTE;

begin
  savescr;
  fila:=wherey;
  columna:=wherex;
  key:=0;
  gotoxy(columna,fila);
   write(#177);

   while key<>28 do
    begin

      key:=getkeycode;

      case key of
           72:fila:=fila-1;
           80:fila:=fila+1;
           77:columna:=columna+1;
           75:columna:=columna-1;
      end;{case}

      if fila=0 then fila:=1;
      if fila=26 then fila:=25;
      if columna=0 then columna:=1;
      if columna=81 then columna:=80;
      restorescr;
      gotoxy(columna,fila);
      write(#177);

   end;{while}
   restorescr;

end;

FUNCTION GETCHAR(FILA,COLUMNA:INTEGER):CHAR;
BEGIN
IF ISCOLOR THEN GETCHAR:=CHR( MEM[$B800:(((FILA-1)*80+(COLUMNA-1))*2)])
ELSE
GETCHAR:=CHR(MEM[$B000:(((FILA-1)*80+(COLUMNA-1))*2)]);
END;


FUNCTION GETLINCHAR(FILA,COL1,COL2:INTEGER):STRING;
VAR
K:INTEGER;
CADENA:STRING;
BEGIN
   col1:=col1-1;
  FOR K:=1 TO (COL2-COL1) DO CADENA:=CADENA+GETCHAR(FILA,COL1+K);
END;


FUNCTION REPLICATE(CADENA:STRING;CUENTA:INTEGER):STRING;

VAR
X:INTEGER;
CADENA2:STRING;
BEGIN
CADENA2:='';
FOR X:=1 TO CUENTA DO CADENA2:=CADENA2+CADENA;
REPLICATE:=CADENA2;
END;

PROCEDURE LOCATE(F,C:INTEGER);
BEGIN
GOTOXY(C,F);
END;

PROCEDURE SAY(F,C:INTEGER;ROTULO:STRING);
BEGIN
LOCATE(F,C);
WRITE(ROTULO);
END;


PROCEDURE SINGLEBOX(F1,C1,F2,C2:INTEGER);
VAR
F:INTEGER;
BEGIN
    SAY(F1,C1,''+REPLICATE('',(C2-C1-1))+'');
    LOCATE(F1+1,C1);
    FOR F:=F1+1 TO F2-1 DO
        BEGIN
          SAY(F,C1,'');
          SAY(F,C2,'');
        END;{for}
    LOCATE(F2,C1);
    WRITE(''+REPLICATE('',(C2-C1-1))+'');
END;

PROCEDURE DOUBLEBOX(F1,C1,F2,C2:INTEGER);
VAR
F:INTEGER;
BEGIN
    SAY(F1,C1,''+REPLICATE('',(C2-C1-1))+'');
    LOCATE(F1+1,C1);
    FOR F:=F1+1 TO F2-1 DO
        BEGIN
          SAY(F,C1,'');
          SAY(F,C2,'');
        END;{for}
    LOCATE(F2,C1);
    WRITE(''+REPLICATE('',(C2-C1-1))+'');
END;

PROCEDURE SAVECURSOR(VAR F,C:INTEGER);
BEGIN
F:=WHEREY;
C:=WHEREX;
END;

PROCEDURE CLEARWINDOW;
BEGIN
WINDOW(1,1,80,25);
END;

PROCEDURE REMOVE(CADENA1:STRING;VAR CADENA2:STRING);
VAR
INTER:STRING;
X,L1,L2:INTEGER;
BEGIN
 INTER:=CADENA2;
 WHILE AT(CADENA1,CADENA2)<>0 DO
    BEGIN
    X:=AT(CADENA1,CADENA2);
    L1:=LEN(CADENA1);
    L2:=LEN(CADENA2);
    CADENA2:=LEFT(CADENA2,X-1) + RIGHT(CADENA2,L2-X+1-L1);
    END;{while}
END;


FUNCTION VALSTR(CADENA:STRING):REAL;
VAR
R:REAL;
I:INTEGER;
X:INTEGER;
K:INTEGER;

BEGIN
 X:=1;
 CADENA:=TRIM(CADENA);
 CADENA:=LTRIM(CADENA);
 K:=0;

 WHILE (X<=LEN(CADENA)) AND (SUBSTR(CADENA,X,1)>=',') AND (SUBSTR(CADENA,X,1)<='9') DO
       BEGIN
        K:=K+1;
        X:=X+1;
       END;


 IF K>0 THEN CADENA:=LEFT(CADENA,K);

 REMOVE(',',CADENA);
 VAL(CADENA,R,I);
 VALSTR:=R;
END;



function encript(cadena:string):string;
var

r:integer;
cadena2:string;
x:integer;
begin
     cadena2:='';
     randomize;
     r:=random(92)+32;
     cadena2:=cadena2+chr(r);
     for x:=1 to length(cadena) do cadena2:=cadena2+chr( ord(cadena[x])+r);
     encript:=cadena2;
end;

function desencript(cadena:string):string;
var

r:integer;
cadena2:string;
x:integer;
begin
     cadena2:='';
     r:=ord(cadena[1]);
     for x:=2 to length(cadena) do cadena2:=cadena2+chr( ord(cadena[x])-r);
     desencript:=cadena2;
end;


procedure loadimage(nomarch:string;var p:pointer;var size:word;var ancho:integer;var largo:integer);

var
numarch: file;
NumWritten: Word;

begin

   Assign(numarch,nomarch);
   Reset(numarch,1);
   Blockread(numarch,size,2,NumWritten);
   Blockread(numarch,ancho,1,NumWritten);
   Blockread(numarch,largo,1,NumWritten);
   getmem(p,size);
   Blockread(numarch,p^,size,NumWritten);
   close(numarch);

end;


procedure setrgb(registro:word;r,g,b:byte);
begin
asm
mov ah,10h
mov al,10h
mov bx,registro
mov ch,g
mov cl,b
mov dh,r
int 10h
end;
end;

procedure getbufer(var tecla,codigo:char);
var
t,c:char;
begin
asm
mov ah,01
int 16h
mov t,al
mov c,ah
end;
tecla:=t;
codigo:=c;

end;

procedure putcharbuf(caracter,codigo:byte);

begin
asm
mov ah,05
mov ch,codigo
mov cl,caracter
int 16h
end;
end;


FUNCTION WRITESECTOR(unidad:STRING;numsec,cilindro,sector,lado:BYTE;VAR buffer:SECTOR):BYTE;
var
unid:byte;
estado:byte;
retrys:byte;
XOFFSET:WORD;


begin

unid:=DRIVEVAL(unidad);
retrys:=0;
estado:=0;
XOFFSET:=OFS(BUFFER);

REPEAT


ASM
  PUSH ES
  MOV AX,DS
  MOV ES,AX

  MOV AH,03H
  MOV AL,&numsec
  MOV CH,&cilindro
  MOV CL,&sector
  MOV DH,&lado
  MOV DL,&unid
  MOV BX,&XOFFSET
  INT 13H
  MOV &estado,AH
  POP ES
END;
INC(RETRYS);

UNTIL (estado=0) OR (RETRYS=3);
WRITESECTOR:=ESTADO;
END;

FUNCTION EXIST(filename:STRING):BOOLEAN;
VAR

  f: file;
begin
  {$I-}
  filemode:=0;
  Assign(f, FileName);
  Reset(f);
  Close(f);
  {$I+}
  Exist := (IOResult = 0) and
   (FileName <> '');
   filemode:=2;

END;


procedure kbdtasa(retardo,velocidad:byte);
begin
asm
mov ah,03h
mov al,05h
mov bh,retardo
mov bl,velocidad
int 16h
end;
end;



PROCEDURE HIDECURSOR;
BEGIN
ASM
  MOV AH,01H
  MOV CH,20H
  MOV CL,0
  INT 10H
END;
END;


PROCEDURE SHOWCURSOR;
BEGIN
ASM
  MOV AH,01H
  MOV CH,6
  MOV CL,7
  INT 10H
END;
END;


function transform(valor:real;ancho,decimals:byte):string;
var
resultado:string;
begin
str(valor:ancho:decimals,resultado);
transform:=resultado;
end;


FUNCTION STRLIKE(CADENA1,CADENA2:STRING):BOOLEAN;
BEGIN
IF LEFT(CADENA1,LEN(CADENA2))=CADENA2 THEN STRLIKE:=TRUE ELSE STRLIKE:=FALSE;
END;


PROCEDURE SET_COLOR(F,B:BYTE);
BEGIN

IF F<>255 THEN TEXTCOLOR(F);
IF B<>255 THEN TEXTBACKGROUND(b);

END;


FUNCTION INSERTSTR(ORIGEN,DESTINO:STRING;INDEX:INTEGER):STRING;
VAR
LDE:INTEGER;
BEGIN
LDE:=LEN(DESTINO);
INSERTSTR:=LEFT(LEFT(DESTINO,INDEX-1)+ORIGEN+RIGHT(DESTINO,LDE-INDEX+1),LDE);
END;


FUNCTION DELSTR(DESTINO:STRING;INDEX,COUNT:INTEGER):STRING;
VAR
TEMP:STRING;
LDE:INTEGER;
BEGIN
LDE:=LEN(DESTINO);
TEMP:=LEFT(DESTINO,INDEX-1)+RIGHT(DESTINO,LDE-((INDEX-1)+COUNT));
DELSTR:=TEMP+REPLICATE(' ',LDE-LEN(TEMP));


END;

PROCEDURE _DATASHOW(CUR:INTEGER);
BEGIN
IF _DATATIPO[CUR]='N' THEN STRING(_DATAPTR[CUR]^):=TRANSFORM(VALSTR(STRING(_DATAPTR[CUR]^)),_DATASIZE[CUR],_DATADEC[CUR]);
LOCATE(_DATAF[CUR],_DATAC[CUR]+LEN(_DATAPROMPT[CUR]));
WRITE(STRING(_DATAPTR[CUR]^));
END;


PROCEDURE GETDATA(F,C:BYTE; PROMPT:STRING;VAR DATA:STRING; TIPO:CHAR);

VAR
S,D:BYTE;

BEGIN

_DK:=_DK+1;
_DATAPTR[_DK]:=@DATA;
_DATATIPO[_DK]:=UPCASE(TIPO);
_DATAF[_DK]:=F;
_DATAC[_DK]:=C;
_DATAPROMPT[_DK]:=PROMPT;

S:=LEN(STRING(_DATAPTR[_DK]^));
D:=AT('.',STRING(_DATAPTR[_DK]^));
IF D<>0 THEN D:=S-D;

_DATASIZE[_DK]:=S;
_DATADEC[_DK]:=D;


END;

function READDATA:byte;

VAR
CAMPO:STRING;
CUR:byte;
SCANCODE:BYTE;
CAR:CHAR;
CPOS:integer;
CURCOL:BYTE;
x:byte;
CASO:BYTE;
ASC:BYTE;

BEGIN
SCANCODE:=0;
CAR:=CHR(0);
CUR:=1;
CPOS:=0;
CURCOL:=TEXTATTR;

    for cur:=1 to _dk do
       begin
         LOCATE(_DATAF[CUR],_DATAC[CUR]);
         WRITE(_DATAPROMPT[CUR]);
         SET_COLOR(_DATACOL1,_DATACOL2);
         WRITE(STRING(_DATAPTR[CUR]^));
         TEXTATTR:=CURCOL;
       end;
     cur:=1;
     LOCATE(_DATAF[CUR],_DATAC[CUR]+LEN(_DATAPROMPT[CUR]));

            SET_COLOR(_DATACOL1,_DATACOL2);
      campo:=STRING(_DATAPTR[CUR]^);
      WHILE TRUE DO
      BEGIN
          scancode:=inkey(car);
          ASC:=ORD(CAR);
          CASO:=0;
          IF (SCANCODE=68) OR (SCANCODE=1) OR ((SCANCODE=73)
             AND (ORD(CAR)=224)) OR ((SCANCODE=81) AND (ORD(CAR)=224)) THEN BREAK;

          IF (SCANCODE=77) AND (ASC=224) THEN CASO:=1;
          IF (SCANCODE=75) AND (ASC=224) THEN CASO:=2;
          IF (SCANCODE=72) AND (ASC=224) THEN CASO:=3;
          IF (SCANCODE=80) AND (ASC=224) THEN CASO:=4;
          IF (SCANCODE=28) OR (SCANCODE=224) OR (SCANCODE=15) THEN CASO:=4;
          IF (SCANCODE=117) THEN              CASO:=5;
          IF (SCANCODE=119) THEN              CASO:=6;
          IF (SCANCODE=71) AND (ASC=224) THEN CASO:=7;
          IF (SCANCODE=79) AND (ASC=224) THEN CASO:=8;
          IF (SCANCODE=82) AND (ASC=224) THEN CASO:=9;
          IF (SCANCODE=83) AND (ASC=224) THEN CASO:=10;
          IF (SCANCODE=14) THEN               CASO:=11;


          CASE caso OF
          1:begin cpos:=cpos+1;if cpos>(len(campo)-1) then cpos:=len(campo)-1;end;
          2:begin cpos:=cpos-1;if cpos<0 then cpos:=0;end;
          3:begin cur:=cur-1;if cur=0 then cur:=_dk;campo:=STRING(_DATAPTR[CUR]^);cpos:=0;end;
          4:begin _DATASHOW(CUR);cur:=cur+1;if cur>_dk then cur:=1;campo:=STRING(_DATAPTR[CUR]^);cpos:=0;end;
          5:begin cur:=_dk;campo:=STRING(_DATAPTR[CUR]^);cpos:=0;end;
          6:begin cur:=1;campo:=STRING(_DATAPTR[CUR]^);cpos:=0;end;
          7:cpos:=0;
          8:cpos:=len(campo)-1;
          9:begin end;

          10:BEGIN STRING(_DATAPTR[CUR]^):=DELSTR(STRING(_DATAPTR[CUR]^),CPOS+1,1);campo:=STRING(_DATAPTR[CUR]^);
                   LOCATE(_DATAF[CUR],_DATAC[CUR]+LEN(_DATAPROMPT[CUR]));WRITE(STRING(_DATAPTR[CUR]^));;END;

          11:BEGIN STRING(_DATAPTR[CUR]^):=DELSTR(STRING(_DATAPTR[CUR]^),CPOS,1);campo:=STRING(_DATAPTR[CUR]^);
                   LOCATE(_DATAF[CUR],_DATAC[CUR]+LEN(_DATAPROMPT[CUR]));
                   WRITE(STRING(_DATAPTR[CUR]^));cpos:=cpos-1;if cpos<0 then cpos:=0;END;


          ELSE
          IF ORD(CAR)<>0 THEN
          BEGIN

          IF _DATATIPO[CUR]='C' THEN
             BEGIN
                 CPOS:=CPOS+1;
                 STRING(_DATAPTR[CUR]^):=INSERTSTR(CAR,STRING(_DATAPTR[CUR]^),CPOS);
                 campo:=STRING(_DATAPTR[CUR]^);
                 _DATASHOW(CUR);
                 if cpos>(len(campo)-1) then cpos:=len(campo)-1;
              END;

          IF (_DATATIPO[CUR]='N') AND ( ((CAR>='0') AND (CAR<='9')) OR (CAR='.'))  THEN
              BEGIN
                 CPOS:=CPOS+1;
                 STRING(_DATAPTR[CUR]^):=INSERTSTR(CAR,STRING(_DATAPTR[CUR]^),CPOS);
                 campo:=STRING(_DATAPTR[CUR]^);
                 LOCATE(_DATAF[CUR],_DATAC[CUR]+LEN(_DATAPROMPT[CUR]));
                 WRITE(STRING(_DATAPTR[CUR]^));
                 if cpos>(len(campo)-1) then cpos:=len(campo)-1;
              END;


           END;{FINAL DE PRESIONARON UN CARACTER'}


          END; {FINAL DEL CASE scancode OF }

          LOCATE(_DATAF[CUR],_DATAC[CUR]+LEN(_DATAPROMPT[CUR])+cpos);
      END;{FINAL SCANCODE<>68 AND SCANCODE<>1}


      readdata:=scancode;
      _DK:=0;
      TEXTATTR:=CURCOL;
END;

PROCEDURE DATACOLOR(COL1,COL2:BYTE);
BEGIN
_DATACOL1:=COL1;
_DATACOL2:=COL2;

END;

FUNCTION SPACE(K:BYTE):STRING;
BEGIN
SPACE:=REPLICATE(' ',K);
END;

procedure shell;
begin
Exec(GetEnv('ComSpec'), '');
end;




{*****************************************}
BEGIN
_DK:=0;
_DATACOL1:=0;
_DATACOL2:=7;


{FIN IMPLEMENTACION}
END.
